// player sprite class implementation function

#include "sprite.h"

Sprite::Sprite()
{
  std::cout << "Default Sprite constructor called!\n";
}

Sprite::Sprite(std::string img_to_load, short x_in, short y_in)
{
  std::cout << "Secondary Sprite constructor called!\n";

  //used to set up initial pos    
  x = x_in;
  y = y_in;

  
  //recieve size of array from constructor args
  //sprite_surface = new SDL_Surface[amount_of_frames];
  
  //load images
  //this also has to come in through the constructor so we know
  //what sprite to load!
  sprite_surface = SDL_LoadBMP(img_to_load.c_str());
  
  if (!sprite_surface)
  {
    std::cout << "Error: Failed to load image! Game must terminate...\n";
    exit(1);
  }
    
  else  //if successful set the transparency color and continue.
    std::cout << "\nSucessfully loaded player image.\n";

}

Sprite::~Sprite(void)
{
  //destructor for freeing any allocated memory
//  int i;
  
  std::cout << "Freeing image from memory...";
//  for (i = 0; i < NUM_FRAMES; i++)
    SDL_FreeSurface(sprite_surface);
    
  std::cout << "Done!\n";
    
}

void Sprite::set_colorKey(int colorKey_in)
{
  //sets the color key value to every direction the player can face. (currently only
  //one, foward..)

//  int i;
  
//  for (i = 0; i < NUM_FRAMES; i++)
    SDL_SetColorKey(sprite_surface, SDL_SRCCOLORKEY | SDL_RLEACCEL, colorKey_in);
}

SDL_Surface* Sprite::get_image(short frame) const
{
  //returns a pointer to the sdl surface with the image.
  //if the image frame is out of bounds, it will return NULL
  //(for error checking)

  if (frame < NUM_FRAMES && frame >= 0)
    return sprite_surface;
  
  else
    return NULL;
}


short Sprite::get_x(void) const
{
  return x;
}

void Sprite::set_x(short x_in)
{
  x += x_in;
}

short Sprite::get_y(void) const
{
  return y;
}

void Sprite::set_y(short y_in)
{
  y += y_in;
}

short Sprite::get_h(void) const
{
  return sprite_surface->h;
}

short Sprite::get_w(void) const
{
  return sprite_surface->w;
}
